diff --git a/core/src/aos_shell.c b/core/src/aos_shell.c
index 2fb9cb4..d3974e4 100644
--- a/core/src/aos_shell.c
+++ b/core/src/aos_shell.c
@@ -35,14 +35,89 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /******************************************************************************/
 
 /**
+ * @brief   The character the input buffer is initialized with.
+ */
+#define INBUF_INIT_CHAR                         '\x07'
+
+/**
  * @brief   Event mask to be set on OS related events.
  */
-#define AOS_SHELL_EVENTMASK_OS                  EVENT_MASK(0)
+#define EVENTMASK_OS                            EVENT_MASK(0)
 
 /**
  * @brief   Event mask to be set on a input event.
  */
-#define AOS_SHELL_EVENTMASK_INPUT               EVENT_MASK(1)
+#define EVENTMASK_INPUT                         EVENT_MASK(1)
+
+/**
+ * @brief   String that defines the INSERT key as specified by VT100.
+ */
+#define KEYSTRING_INSERT                        "\x1B\x5B\x32\x7E"
+
+/**
+ * @brief   String that defines the DEL key as specified by VT100.
+ */
+#define KEYSTRING_DELETE                        "\x1B\x5B\x33\x7E"
+
+/**
+ * @brief   String that defines the HOME key as specified by VT100.
+ */
+#define KEYSTRING_HOME                          "\x1B\x5B\x48"
+
+/**
+ * @brief   String that defines the END key as specified by VT100.
+ */
+#define KEYSTRING_END                           "\x1B\x5B\x46"
+
+/**
+ * @brief   String that defines the PGUP key as specified by VT100.
+ */
+#define KEYSTRING_PAGEUP                        "\x1B\x5B\x35\x7E"
+
+/**
+ * @brief   String that defines the PGUP key as specified by VT100.
+ */
+#define KEYSTRING_PAGEDOWN                      "\x1B\x5B\x36\x7E"
+
+/**
+ * @brief   String that defines the 'arrow down' key as specified by VT100.
+ */
+#define KEYSTRING_ARROWUP                       "\x1B\x5B\x41"
+
+/**
+ * @brief   String that defines the 'arrow up' key as specified by VT100.
+ */
+#define KEYSTRING_ARROWDOWN                     "\x1B\x5B\x42"
+
+/**
+ * @brief   String that defines the 'arrow left' key as specified by VT100.
+ */
+#define KEYSTRING_ARROWLEFT                     "\x1B\x5B\x44"
+
+/**
+ * @brief   String that defines the 'arrow right' key as specified by VT100.
+ */
+#define KEYSTRING_ARROWRIGHT                    "\x1B\x5B\x43"
+
+/**
+ * @brief   String that defines the CRTL + 'arrow up' key combination as specified by VT100.
+ */
+#define KEYSTRING_CTRL_ARROWUP                  "\x1B\x5B\x31\x3B\x35\x41"
+
+/**
+ * @brief   String that defines the CRTL + 'arrow down' key combination as specified by VT100.
+ */
+#define KEYSTRING_CTRL_ARROWDOWN                "\x1B\x5B\x31\x3B\x35\x42"
+
+/**
+ * @brief   String that defines the CRTL + 'arrow left' key combination as specified by VT100.
+ */
+#define KEYSTRING_CTRL_ARROWLEFT                "\x1B\x5B\x31\x3B\x35\x44"
+
+/**
+ * @brief   String that defines the CRTL + 'arrow right' key combination as specified by VT100.
+ */
+#define KEYSTRING_CTRL_ARROWRIGHT               "\x1B\x5B\x31\x3B\x35\x43"
 
 /******************************************************************************/
 /* EXPORTED VARIABLES                                                         */
@@ -97,22 +172,23 @@ typedef enum special_key {
   KEY_UNKNOWN,          /**< any/unknow key */
   KEY_AMBIGUOUS,        /**< key is ambiguous */
   KEY_TAB,              /**< tabulator key */
-  KEY_ESCAPE,           /**< escape key */
   KEY_BACKSPACE,        /**< backspace key */
   KEY_INSERT,           /**< insert key */
   KEY_DELETE,           /**< delete key */
+  KEY_ESCAPE,           /**< escape key */
   KEY_HOME,             /**< home key */
   KEY_END,              /**< end key */
-  KEY_PAGE_UP,          /**< page up key */
-  KEY_PAGE_DOWN,        /**< page down key */
-  KEY_ARROW_UP,         /**< arrow up key */
-  KEY_ARROW_DOWN,       /**< arrow down key */
-  KEY_ARROW_LEFT,       /**< arrow left key */
-  KEY_ARROW_RIGHT,      /**< arrow right key */
-  KEY_CTRL_ARROW_UP,    /**< CTRL + arrow up key */
-  KEY_CTRL_ARROW_DOWN,  /**< CTRL + arrow down key */
-  KEY_CTRL_ARROW_LEFT,  /**< CTRL + arrow left key */
-  KEY_CTRL_ARROW_RIGHT, /**< CTRL + arrow right key */
+  KEY_PAGEUP,           /**< page up key */
+  KEY_PAGEDOWN,         /**< page down key */
+  KEY_ARROWUP,          /**< arrow up key */
+  KEY_ARROWDOWN,        /**< arrow down key */
+  KEY_ARROWLEFT,        /**< arrow left key */
+  KEY_ARROWRIGHT,       /**< arrow right key */
+  KEY_CTRL_ARROWUP,     /**< CTRL + arrow up key */
+  KEY_CTRL_ARROWDOWN,   /**< CTRL + arrow down key */
+  KEY_CTRL_ARROWLEFT,   /**< CTRL + arrow left key */
+  KEY_CTRL_ARROWRIGHT,  /**< CTRL + arrow right key */
+  KEY_CTRL_C,           /**< CTRL + C key */
 } special_key_t;
 
 /**
@@ -124,6 +200,92 @@ typedef enum charmatch {
   CHAR_MATCH_CASE   = 2,  /**< Characters do match with case. */
 } charmatch_t;
 
+/**
+ * @brief   Enumerator to encode shell actions.
+ */
+typedef enum aos_shellaction {
+  ACTION_NONE,                  /**< No action at all. */
+  ACTION_READCHAR,              /**< Read a printable character. */
+  ACTION_AUTOCOMPLETE,          /**< Automatically comlete input by using available command. */
+  ACTION_SUGGEST,               /**< Suggest matching available commands. */
+  ACTION_EXECUTE,               /**< Execute input. */
+  ACTION_DELETEBACKWARD,        /**< Delete a single character backwards. */
+  ACTION_DELETEFORWARD,         /**< Delete a single character forwards. */
+  ACTION_CLEAR,                 /**< Clear the input. */
+  ACTION_RECALLPREVIOUS,        /**< Recall the previous (older) entry in the history. */
+  ACTION_RECALLNEXT,            /**< Recall the next (more recent) entry in the history. */
+  ACTION_RECALLOLDEST,          /**< Recall the oldest entry in the history. */
+  ACTION_RECALLCURRENT,         /**< Recall the current input. */
+  ACTION_CURSORLEFT,            /**< Move cursor one character to the left. */
+  ACTION_CURSORRIGHT,           /**< Move cursor one character to the right. */
+  ACTION_CURSORWORDLEFT,        /**< Move cursor one word to the left. */
+  ACTION_CURSORWORDRIGHT,       /**< Move cursor one word to the right. */
+  ACTION_CURSOR2END,            /**< Move cursor to the very right. */
+  ACTION_CURSOR2START,          /**< Move cursor to the very left. */
+  ACTION_RESET,                 /**< Reset the current input. */
+  ACTION_INSERTTOGGLE,          /**< Toggle insertion mode. */
+  ACTION_ESCSTART,              /**< Start an escape sequence (special keys). */
+  ACTION_PRINTUNKNOWNSEQUENCE,  /**< Print an unknown escape sequence. */
+} action_t;
+
+/**
+ * @brief   Struct that holds most important runtime data for the shell.
+ * @details The structure is to be used by the shell thread main function as some kind of structured stack, which can be easily passed to other functions.
+ */
+typedef struct runtimedata {
+  /**
+   * @brief   Data related to the current input.
+   */
+  struct {
+    /**
+     * @brief   Length of the input.
+     */
+    size_t length;
+
+    /**
+     * @brief   Current position of the cursor in the input line.
+     */
+    size_t cursorpos;
+
+    /**
+     * @brief   Buffer to store escape sequences, which describe special characters.
+     */
+    char escseq[AOS_SHELL_ESCSEQUENCE_LENGTH];
+  } input;
+
+  /**
+   * @brief   Data related to the entry or history buffer.
+   */
+  struct {
+    /**
+     * @brief   Current entry to be filled and executed.
+     */
+    size_t current;
+
+    /**
+     * @brief   Selected entry in the 'history' as preview.
+     * @details A value of 0 indicates, that the line is cleared as a preview.
+     *          A value of 1 indicates, that the current entry is selected.
+     *          A value of t>1 indicates, that the entry t-1 in the past is selected.
+     *          The value must never be greater than the number of entries available, of course.
+     */
+    size_t selected;
+
+    /**
+     * @brief   Selected entry in the 'history' that has been edited by the user.
+     *          A value of 0 indicates, that there was no modification by the user yet (i.e. charcters, deletions or autofill).
+     *          A value of 1 indicates, that the current entry was edited.
+     *          A value of t>1 indicated, that a history entry was recalled and then edited.
+     */
+    size_t edited;
+  } buffer;
+
+  /**
+   * @brief   The last action executed by the shell.
+   */
+  action_t lastaction;
+} runtimedata_t;
+
 /******************************************************************************/
 /* LOCAL VARIABLES                                                            */
 /******************************************************************************/
@@ -248,6 +410,9 @@ static msg_t _channelctl(void *instance, unsigned int operation, void *arg)
   return MSG_OK;
 }
 
+/**
+ * @brief   Implementation of the BaseSequentialStream write() method.
+ */
 static size_t _streamwrite(void *instance, const uint8_t *bp, size_t n)
 {
   aosDbgCheck(instance != NULL);
@@ -267,6 +432,9 @@ static size_t _streamwrite(void *instance, const uint8_t *bp, size_t n)
   return maxbytes;
 }
 
+/**
+ * @brief   Implementation of the BaseSequentialStream read() method.
+ */
 static size_t _stremread(void *instance, uint8_t *bp, size_t n)
 {
   (void)instance;
@@ -276,6 +444,9 @@ static size_t _stremread(void *instance, uint8_t *bp, size_t n)
   return 0;
 }
 
+/**
+ * @brief   Implementation of the BaseSequentialStream put() method.
+ */
 static msg_t _streamput(void *instance, uint8_t b)
 {
   aosDbgCheck(instance != NULL);
@@ -294,6 +465,9 @@ static msg_t _streamput(void *instance, uint8_t b)
   return ret;
 }
 
+/**
+ * @brief   Implementation of the BaseSequentialStream get() method.
+ */
 static msg_t _streamget(void *instance)
 {
   (void)instance;
@@ -302,6 +476,121 @@ static msg_t _streamget(void *instance)
 }
 
 /**
+ * @brief   Retreive a pointer to the string buffer of a specified entry in the input buffer.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] entry   Entry to be retrieved.
+ *
+ * @return  Pointer to the entry in the input buffer.
+ */
+static inline char* _getAbsoluteEntry(const aos_shell_t* shell, size_t entry)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(entry < shell->input.nentries);
+
+  return &(shell->input.buffer[entry * shell->input.linewidth * sizeof(char)]);
+}
+
+/**
+ * @brief   Calculate absolute entry from history offset.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] rdata   Pointer to a runtime data object.
+ * @param[in] offset  Relative offset of the entry to be retreived.
+ *
+ * @return  Absolute index of the historic entry.
+ */
+static inline size_t _historyOffset2EntryIndex(const aos_shell_t* shell, const runtimedata_t* rdata, size_t offset)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
+  aosDbgCheck(offset < shell->input.nentries);
+
+  return ((shell->input.nentries + rdata->buffer.current - offset) % shell->input.nentries);
+}
+
+/**
+ * @brief   Retreive a pointer to the string buffer of a historic entry in the input buffer.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] rdata   Pointer to a runtime data object.
+ * @param[in] offset  Relative offset of the entry to be retreived.
+ *
+ * @return  Pointer to the entry in the input buffer.
+ */
+static inline char* _getRelativeEntry(const aos_shell_t* shell, const runtimedata_t* rdata, size_t offset)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
+  aosDbgCheck(offset < shell->input.nentries);
+
+  return _getAbsoluteEntry(shell, _historyOffset2EntryIndex(shell, rdata, offset));
+}
+
+/**
+ * @brief   Retreive a pointer to the current entry string in the input buffer.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] rdata   Pointer to a runtime data object.
+ *
+ * @return  Pointer to the string of the current entry in the input buffer.
+ */
+static inline char* _getCurrentEntry(const aos_shell_t* shell, const runtimedata_t* rdata)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
+
+  return _getAbsoluteEntry(shell, rdata->buffer.current);
+}
+
+/**
+ * @brief   Retreive a pointer to the currently selected entry.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] rdata   Pointer to a runtime data object.
+ *
+ * @return  Pointer to the currently selected entry or NULL if no entry is selected (cleared preview).
+ */
+static inline char* _getSelectedEntry(const aos_shell_t* shell, const runtimedata_t* rdata)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
+
+  if (rdata->buffer.selected > 0) {
+    return _getRelativeEntry(shell, rdata, rdata->buffer.selected - 1);
+  } else {
+    return NULL;
+  }
+}
+
+/**
+ * @brief   Retreive the currently visualized entry.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] rdata   Pointer to a runtime data object.
+ *
+ * @return  Pointer to the currently visualized entry or NULL if the input has been cleared (cleared preview).
+ */
+static inline char* _getVisualisedEntry(const aos_shell_t* shell, const runtimedata_t* rdata)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
+
+  if (rdata->buffer.selected == 0) {
+    // cleared preview, nothing visualized
+    return NULL;
+  } else {
+    if (rdata->buffer.selected == 1 || rdata->buffer.selected == rdata->buffer.edited) {
+      // the current or a modified entry is selected
+      return _getCurrentEntry(shell, rdata);
+    } else {
+      // a historic, unmodified entry is selected
+      return _getRelativeEntry(shell, rdata, rdata->buffer.selected - 1);
+    }
+  }
+}
+
+/**
  * @brief   Print the shell prompt
  * @details Depending on the configuration flags, the system uptime is printed before the prompt string.
  *
@@ -371,167 +660,181 @@ static void _printPrompt(aos_shell_t* shell)
 static special_key_t _interpreteEscapeSequence(const char seq[])
 {
   // local variables
-  char str[AOS_SHELL_ESCSEQUENCE_LENGTH];
   unsigned long strl = 0;
   const unsigned long seql = strlen(seq);
   bool ambiguous = false;
 
   // TAB
-  /* not supported yet; use "\x09" instead */
+  /* not supported yet; use '\x09' instead */
 
   // BACKSPACE
-  /* not supported yet; use "\x08" instead */
+  /* not supported yet; use '\x08' instead */
 
   // ESCAPE
-  strncpy(str, "\x1B", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_ESCAPE;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
-  }
+  /* not supported yes; use '\x1B' instead */
+
+  // CTRL + C
+  /* not defined yet; use '\x03' instead */
 
   // INSERT
-  strncpy(str, "\x1B\x5B\x32\x7E", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_INSERT;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_INSERT, seql) == 0) {
+    strl = strlen(KEYSTRING_INSERT);
+    if (seql == strl) {
+      return KEY_INSERT;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // DELETE
-  strncpy(str, "\x1B\x5B\x33\x7E", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_DELETE;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_DELETE, seql) == 0) {
+    strl = strlen(KEYSTRING_DELETE);
+    if (seql == strl) {
+      return KEY_DELETE;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // HOME
-  strncpy(str, "\x1B\x5B\x48", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_HOME;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_HOME, seql) == 0) {
+    strl = strlen(KEYSTRING_HOME);
+    if (seql == strl) {
+      return KEY_HOME;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // END
-  strncpy(str, "\x1B\x5B\x46", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_END;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_END, seql) == 0) {
+    strl = strlen(KEYSTRING_END);
+    if (seql == strl) {
+      return KEY_END;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // PAGE UP
-  strncpy(str, "\x1B\x5B\x35\x7E", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_PAGE_UP;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_PAGEUP, seql) == 0) {
+    strl = strlen(KEYSTRING_PAGEUP);
+    if (seql == strl) {
+      return KEY_PAGEUP;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // PAGE DOWN
-  strncpy(str, "\x1B\x5B\x36\x7E", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_PAGE_DOWN;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_PAGEDOWN, seql) == 0) {
+    strl = strlen(KEYSTRING_PAGEDOWN);
+    if (seql == strl) {
+      return KEY_PAGEDOWN;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // ARROW UP
-  strncpy(str, "\x1B\x5B\x41", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_ARROW_UP;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_ARROWUP, seql) == 0) {
+    strl = strlen(KEYSTRING_ARROWUP);
+    if (seql == strl) {
+      return KEY_ARROWUP;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // ARROW DOWN
-  strncpy(str, "\x1B\x5B\x42", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_ARROW_DOWN;
-  } else if (seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_ARROWDOWN, seql) == 0) {
+    strl = strlen(KEYSTRING_ARROWDOWN);
+    if (seql == strl) {
+      return KEY_ARROWDOWN;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // ARROW LEFT
-  strncpy(str, "\x1B\x5B\x44", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_ARROW_LEFT;
-  } else if (seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_ARROWLEFT, seql) == 0) {
+    strl = strlen(KEYSTRING_ARROWLEFT);
+    if (seql == strl) {
+      return KEY_ARROWLEFT;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // ARROW RIGHT
-  strncpy(str, "\x1B\x5B\x43", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_ARROW_RIGHT;
-  } else if (seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_ARROWRIGHT, seql) == 0) {
+    strl = strlen(KEYSTRING_ARROWRIGHT);
+    if (seql == strl) {
+      return KEY_ARROWRIGHT;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // CTRL + ARROW UP
-  strncpy(str, "\x1B\x5B\x31\x3B\x35\x41", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_CTRL_ARROW_UP;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_CTRL_ARROWUP, seql) == 0) {
+    strl = strlen(KEYSTRING_CTRL_ARROWUP);
+    if (seql == strl) {
+      return KEY_CTRL_ARROWUP;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // CTRL + ARROW DOWN
-  strncpy(str, "\x1B\x5B\x31\x3B\x35\x42", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_CTRL_ARROW_DOWN;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_CTRL_ARROWDOWN, seql) == 0) {
+    strl = strlen(KEYSTRING_CTRL_ARROWDOWN);
+    if (seql == strl) {
+      return KEY_CTRL_ARROWDOWN;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // CTRL + ARROW LEFT
-  strncpy(str, "\x1B\x5B\x31\x3B\x35\x44", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_CTRL_ARROW_LEFT;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_CTRL_ARROWLEFT, seql) == 0) {
+    strl = strlen(KEYSTRING_CTRL_ARROWLEFT);
+    if (seql == strl) {
+      return KEY_CTRL_ARROWLEFT;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   // CTRL + ARROW RIGHT
-  strncpy(str, "\x1B\x5B\x31\x3B\x35\x43", AOS_SHELL_ESCSEQUENCE_LENGTH);
-  strl = strlen(str);
-  if (seql == strl && strncmp(seq, str, seql) == 0) {
-    return KEY_CTRL_ARROW_RIGHT;
-  } else if(seql < strl && strncmp(seq, str, seql) == 0) {
-    ambiguous = true;
+  if (strncmp(seq, KEYSTRING_CTRL_ARROWRIGHT, seql) == 0) {
+    strl = strlen(KEYSTRING_CTRL_ARROWRIGHT);
+    if (seql == strl) {
+      return KEY_CTRL_ARROWRIGHT;
+    } else if (seql < strl) {
+      ambiguous = true;
+    }
   }
 
   return ambiguous ? KEY_AMBIGUOUS : KEY_UNKNOWN;
 }
 
 /**
- * @brief   Move the cursor in the terminal
+ * @brief   Move the cursor in the terminal.
  *
  * @param[in] shell   Pointer to the shell object.
+ * @param[in] line    Pointer to the current content of the line.
  * @param[in] from    Starting position of the cursor.
  * @param[in] to      Target position to move the cursor to.
  *
  * @return            The number of positions moved.
  */
-static int _moveCursor(aos_shell_t* shell, const size_t from, const size_t to)
+static int _moveCursor(aos_shell_t* shell, const char* line, size_t from, size_t to)
 {
   aosDbgCheck(shell != NULL);
+  aosDbgCheck(line !=  NULL || from >= to);
+  aosDbgCheck(from <= shell->input.linewidth);
+  aosDbgCheck(to <= shell->input.linewidth);
 
   // local variables
   size_t pos = from;
@@ -544,7 +847,7 @@ static int _moveCursor(aos_shell_t* shell, const size_t from, const size_t to)
 
   // move cursor right by printing line content
   while (pos < to) {
-    streamPut(&shell->stream, (uint8_t)shell->input.line[pos]);
+    streamPut(&shell->stream, (uint8_t)line[pos]);
     ++pos;
   }
 
@@ -552,61 +855,111 @@ static int _moveCursor(aos_shell_t* shell, const size_t from, const size_t to)
 }
 
 /**
- * @brief   Print content of the shell line
+ * @brief   Print content of a given string to the shell output stream.
  *
  * @param[in] shell   Pointer to the shell object.
+ * @param[in] line    Pointer to the line to be printed.
  * @param[in] from    First position to start printing from.
  * @param[in] to      Position after the last character to print.
  *
  * @return            Number of characters printed.
  */
-static inline size_t _printLine(aos_shell_t* shell, const size_t from, const size_t to)
+static size_t _printString(aos_shell_t* shell, const char* line, size_t from, size_t to)
 {
   aosDbgCheck(shell != NULL);
+  aosDbgCheck(line != NULL || from >= to);
+  aosDbgCheck(from < shell->input.linewidth);
+  aosDbgCheck(to <= shell->input.linewidth);
 
   // local variables
   size_t cnt;
 
   for (cnt = 0; from + cnt < to; ++cnt) {
-    streamPut(&shell->stream, (uint8_t)shell->input.line[from + cnt]);
+    streamPut(&shell->stream, (uint8_t)line[from + cnt]);
   }
 
   return cnt;
 }
 
-static int _readChar(aos_shell_t* shell, const char c) {
+/**
+ * @brief   Print a single character to the input buffer and to the output stream.
+ *
+ * @param[in] shell   Pointer to the shell object.
+ * @param[in] rdata   Pointer to the runtim data object.
+ * @param[in] c       Character to print.
+ *
+ * @return  Number of successfully handled characters.
+ *          The return value can be interpreted as boolean (1 = sucess; 0 = error).
+ */
+static int _printChar(aos_shell_t* shell, runtimedata_t* rdata, char c)
+{
   aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
 
   // check whether input line is already full
-  if (shell->inputdata.lineend + 1 >= shell->input.size) {
+  if (rdata->input.length + 1 >= shell->input.linewidth) {
     return 0;
-  } else {
-    // clear old line content on first input
-    if (shell->inputdata.noinput) {
-      memset(shell->input.line, '\0', shell->input.size);
-      shell->inputdata.noinput = false;
-    }
-    // overwrite content
-    if (shell->config & AOS_SHELL_CONFIG_INPUT_OVERWRITE) {
-      shell->input.line[shell->inputdata.cursorpos] = c;
-      ++shell->inputdata.cursorpos;
-      shell->inputdata.lineend = (shell->inputdata.cursorpos > shell->inputdata.lineend) ? shell->inputdata.cursorpos : shell->inputdata.lineend;
-      streamPut(&shell->stream, (uint8_t)c);
-    }
-    // insert character
-    else {
-      memmove(&(shell->input.line[shell->inputdata.cursorpos+1]), &(shell->input.line[shell->inputdata.cursorpos]), shell->inputdata.lineend - shell->inputdata.cursorpos);
-      shell->input.line[shell->inputdata.cursorpos] = c;
-      ++shell->inputdata.lineend;
-      _printLine(shell, shell->inputdata.cursorpos, shell->inputdata.lineend);
-      ++shell->inputdata.cursorpos;
-      _moveCursor(shell, shell->inputdata.lineend, shell->inputdata.cursorpos);
-    }
+  }
+
+  // retreive entry in the input buffer
+  char* line = _getCurrentEntry(shell, rdata);
+
+  // overwrite content
+  if (shell->config & AOS_SHELL_CONFIG_INPUT_OVERWRITE) {
+    line[rdata->input.cursorpos] = c;
+    ++rdata->input.cursorpos;
+    rdata->input.length = (rdata->input.cursorpos > rdata->input.length) ? rdata->input.cursorpos : rdata->input.length;
+    streamPut(&shell->stream, (uint8_t)c);
+    return 1;
+  }
+  // insert character
+  else {
+    memmove(&line[rdata->input.cursorpos + 1], &line[rdata->input.cursorpos], rdata->input.length - rdata->input.cursorpos);
+    line[rdata->input.cursorpos] = c;
+    ++rdata->input.length;
+    _printString(shell, line, rdata->input.cursorpos, rdata->input.length);
+    ++rdata->input.cursorpos;
+    _moveCursor(shell, line, rdata->input.length, rdata->input.cursorpos);
     return 1;
   }
 }
 
 /**
+ * @brief   Overwrite the current output with a given line.
+ * @details If the current output is longer than the string, the additional characters are cleared.
+ *
+ * @param[in] shell   Pointer to a shell object.
+ * @param[in] rdata   Pointer to a runtime data object.
+ * @param[in] line    The line to be printed.
+ */
+static void _overwriteOutput(aos_shell_t* shell, runtimedata_t* rdata, const char* line)
+{
+  aosDbgCheck(shell != NULL);
+  aosDbgCheck(rdata != NULL);
+  aosDbgCheck(line != NULL);
+
+  // local variables
+  const size_t oldlength = rdata->input.length;
+
+  // print line (overwrite current output)
+  _moveCursor(shell, line, rdata->input.cursorpos, 0);
+  rdata->input.length = strlen(line);
+  _printString(shell, line, 0, rdata->input.length);
+
+  // clear any remaining symbols
+  if (oldlength > rdata->input.length) {
+    for (rdata->input.cursorpos = rdata->input.length; rdata->input.cursorpos < oldlength; ++rdata->input.cursorpos) {
+      streamPut(&shell->stream, ' ');
+    }
+    _moveCursor(shell, line, oldlength, rdata->input.length);
+  }
+
+  rdata->input.cursorpos = rdata->input.length;
+
+  return;
+}
+
+/**
  * @brief   Compare two characters.
  *
  * @param[in] lhs       First character to compare.
@@ -642,7 +995,7 @@ static inline charmatch_t _charcmp(char lhs, char rhs)
  *
  * @return    The customly encoded character.
  */
-static inline char _mapAscii2Custom(const char c)
+static inline char _mapAscii2Custom(char c)
 {
   if (c >= 'A' && c <= 'Z') {
     return ((c - 'A') * 2) + 'A' + 1;
